/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "HW_Configs.h"

//   ------------------------------------------------------

//   -----------------------------------------------------------

//    ----------------------------------------

/////////////  ,    /////////////////////////
void SYS_Config(void)
{
	//    -----------------------------------------------------
#ifdef NODEBUG
	if (FLASH_OB_GetRDP() == RESET) //     
	{
		FLASH_OB_Unlock(); //  
		FLASH_OB_RDPConfig(OB_RDP_Level_1);
		FLASH_OB_Lock(); //  
	}
#endif  

	//   -----------------------------------------------------------
#ifdef W_DOG
	IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable); //     
	IWDG_SetPrescaler(IWDG_Prescaler_16); // 40 / 16 = 400 -  
	IWDG_SetReload(2500); // 0.4 * 2500 = 1  -  
	while(IWDG_GetFlagStatus(IWDG_FLAG_RVU) != RESET) {} //  
	IWDG_ReloadCounter(); //  
	IWDG_Enable(); //     LSI
#endif  

	SystemCoreClockUpdate (); //  SystemCoreClock =  
}


///////////// Configures GPIO //////////////////////////////////////////
void GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure; //    

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE); //     AHB
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE); //     AHB

	GPIO_DeInit(GPIOA); //   " "
	GPIO_DeInit(GPIOB); //   " "

	// SCL,SDA I2C1
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource8, GPIO_AF_4); //   I2C1
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource9, GPIO_AF_4); //   I2C1

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; // 		
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; // 
	GPIO_Init(GPIOB, &GPIO_InitStructure); 

	//  / TIM17_CH1 PWM 
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_1); //   TIM17_CH1 PWM

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// PA0	-->  / 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// -->  (,  )
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN; //  
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_Init(GPIOB, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_10;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; //  
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// --> 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_Init(GPIOB, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_8|GPIO_Pin_15; //   
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// PA11,PA12 (USB)  

	// PA13,PA14 (SWDIO,SWCLK)   -       .
}


///////////////////////////// Configures ADC ///////////////////////////////////////////
void ADC_Config(void)
{
	ADC_InitTypeDef ADC_InitStructure;
	ADC_CommonInitTypeDef ADC_CommonInitStructure;
	uint32_t  calibration_value = 0;

	RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div4); // Configure the ADC clock
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_ADC12, ENABLE);  // Enable ADC1 clock

 	ADC_StructInit(&ADC_InitStructure);
	ADC_VoltageRegulatorCmd(ADC1, ENABLE); // Calibration procedure
	DELAY_US(10);
  	ADC_SelectCalibrationMode(ADC1, ADC_CalibrationMode_Single);
	ADC_StartCalibration(ADC1);
  
	while(ADC_GetCalibrationStatus(ADC1) != RESET){};
	calibration_value = ADC_GetCalibrationValue(ADC1);
     
	ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;                                                                    
	ADC_CommonInitStructure.ADC_Clock = ADC_Clock_AsynClkMode;                    
	ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_Disabled;             
	ADC_CommonInitStructure.ADC_DMAMode = ADC_DMAMode_OneShot;                  
	ADC_CommonInitStructure.ADC_TwoSamplingDelay = 0;          
	ADC_CommonInit(ADC1, &ADC_CommonInitStructure);
  
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_ContinuousConvMode_Enable;
	ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b; 
	ADC_InitStructure.ADC_ExternalTrigConvEvent = ADC_ExternalTrigConvEvent_0;         
	ADC_InitStructure.ADC_ExternalTrigEventEdge = ADC_ExternalTrigEventEdge_None;
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
	ADC_InitStructure.ADC_OverrunMode = ADC_OverrunMode_Disable;   
	ADC_InitStructure.ADC_AutoInjMode = ADC_AutoInjec_Disable;  
	ADC_InitStructure.ADC_NbrOfRegChannel = 1;
	ADC_Init(ADC1, &ADC_InitStructure);

	ADC_RegularChannelConfig(ADC1, ADC_Channel_1, 1, ADC_SampleTime_19Cycles5);
	ADC_Cmd(ADC1, ENABLE);  // Enable ADC1
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_RDY)){};  // wait for ADRDY 
	ADC_StartConversion(ADC1);  // Start ADC1 Software Conversion 
}


///////////////////////////// Configures I2C ///////////////////////////////////////////
void I2C_Config(void)
{
	I2C_InitTypeDef I2C_InitStructure; //   

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE); //     APB1
//	RCC_I2CCLKConfig(RCC_I2C1CLK_SYSCLK); // Configure I2C clock

	I2C_DeInit(I2C1); //   " "
	I2C_InitStructure.I2C_Timing = 0x00E0257A; // (I2C_Timing_Config_Tool) 400k  72M
	I2C_InitStructure.I2C_AnalogFilter = I2C_AnalogFilter_Enable;
	I2C_InitStructure.I2C_DigitalFilter = 0x00; // digital noise filter. 0x00...0x0F
	I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
	I2C_InitStructure.I2C_OwnAddress1 = 0x00; // ..
	I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
	I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
	I2C_Init(I2C1, &I2C_InitStructure); // 
	I2C_Cmd(I2C1, ENABLE); // 
}

///////////////////////////// Configures TIMERS ///////////////////////////////////////////
void TIM_Config(void) // ---------------------------------------------
{ 
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure; //   
	TIM_OCInitTypeDef  TIM_OCInitStructure;

	// *************** TIM17 -  *****************************
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM17, ENABLE); //  
	TIM_DeInit(TIM17); //   " "
	TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1; // 0       ETR
	TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up; // 
	TIM_TimeBaseInitStructure.TIM_Period = 12000; // 5.3
	TIM_TimeBaseInitStructure.TIM_Prescaler = 0x0000; //    TIM_Prescaler+1,   1
	TIM_TimeBaseInitStructure.TIM_RepetitionCounter = 0x00; //   TIM1,    
	TIM_TimeBaseInit(TIM17, &TIM_TimeBaseInitStructure); // 

	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1; //  TIM_OCMode_PWM2 -  
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable; //  - 
	TIM_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Disable; //   
	TIM_OCInitStructure.TIM_Pulse = 0; //  
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High; //    - "1" 
	TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Reset; //     Idle (TIM1 only)
	TIM_OCInitStructure.TIM_OCNPolarity = TIM_OCNPolarity_High; //      (TIM1 only)
	TIM_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset; //      Idle (TIM1 only)
	TIM_OC1Init(TIM17, &TIM_OCInitStructure);
	TIM_CtrlPWMOutputs(TIM17, ENABLE);
	TIM_Cmd(TIM17, ENABLE); // 
}


/////////////    /////////////////////
void NVIC_Config(void)
{
	NVIC_InitTypeDef NVIC_InitStructure; //     

	//    I2C
	NVIC_InitStructure.NVIC_IRQChannel = I2C1_EV_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3; // ?
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3; // ?
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); // 

	//      ( = ?,  )
	SysTick_Config(SystemCoreClock / 1000); // 1 mS
}

// -------------------------------------------------------------------------------------------------------



