/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "amg88xx.h"

//   ------------------------------------------------------

//   -----------------------------------------------------------

//    ----------------------------------------


// I2C_TransferHandling(I2C1, uint16_t Address, uint8_t Number_Bytes, uint32_t ReloadEndMode, uint32_t StartStopMode)
//  Address:   ()
//  Number_Bytes:        . 0..255.
//  ReloadEndMode:   .
//     I2C_Reload_Mode:    Number_Bytes    Number_Bytes.
//     I2C_AutoEnd_Mode:   Number_Bytes   "Stop".
//     I2C_SoftEnd_Mode:   . Number_Bytes  .
//  StartStopMode:   .
//     I2C_No_StartStop:    "Start",  "Stop".
//     I2C_Generate_Stop:  "Stop"    , (Number_Bytes should be set to 0).
//     I2C_Generate_Start_Read:  "Start/Restart"    "1"    - .
//     I2C_Generate_Start_Write:  "Start/Restart" - .

/////////////////////////////      ///////////////////////////////////////////
void Amg88xx_StartReadInt(void)
{

	while(I2C_GetFlagStatus(I2C1, I2C_ISR_BUSY) != RESET){}; //   
lab1:
	I2C_ClearFlag(I2C1, I2C_ICR_NACKCF); //   NACKCF

	//  : , ,  , ,   
	I2C_TransferHandling(I2C1, AMG_ADDR, 1, I2C_SoftEnd_Mode, I2C_Generate_Start_Write);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET) // ,   TXIS   
	{
		if (I2C_GetFlagStatus(I2C1, I2C_FLAG_NACKF) == SET) // NACK  - 
		{
			while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
			I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
			goto lab1; // 
		}
	}

	I2C_SendData(I2C1, 0x80); //  
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TC) == RESET){}; //   TC    

	I2C_ITConfig(I2C1, I2C_IT_RXI, ENABLE); //     

	//  : , ,  Number  , 
	I2C_TransferHandling(I2C1, AMG_ADDR, 64*2, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);

	//     
}


/////////////////////////////   ///////////////////////////////////////////
void Amg88xx_ReadArray(uint16_t *Buffer)
{
	uint8_t pix;

	while(I2C_GetFlagStatus(I2C1, I2C_ISR_BUSY) != RESET){}; //   
lab1:
	I2C_ClearFlag(I2C1, I2C_ICR_NACKCF); //   NACKCF

	//  : , ,  , ,   
	I2C_TransferHandling(I2C1, AMG_ADDR, 1, I2C_SoftEnd_Mode, I2C_Generate_Start_Write);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET) // ,   TXIS   
	{
		if (I2C_GetFlagStatus(I2C1, I2C_FLAG_NACKF) == SET) // NACK  - 
		{
			while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
			I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
			goto lab1; // 
		}
	}

	I2C_SendData(I2C1, 0x80); //  
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TC) == RESET){}; //   TC    

	//  : , ,  Number  , 
	I2C_TransferHandling(I2C1, AMG_ADDR, 64*2, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);

	pix = 0;
	while (pix < 64) //  64  
	{
		while(I2C_GetFlagStatus(I2C1, I2C_ISR_RXNE) == RESET){}; // ,   RXNE   
		Buffer[pix] = I2C_ReceiveData(I2C1); //  

		while(I2C_GetFlagStatus(I2C1, I2C_ISR_RXNE) == RESET){}; // ,   RXNE   
		Buffer[pix] |= (uint16_t)I2C_ReceiveData(I2C1) << 8; //  

		pix++;
	}
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
	I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
}


/////////////////////////////    ///////////////////////////////////////////
uint8_t Amg88xx_Read(uint8_t ReadAddr)
{
	uint8_t data;

	while(I2C_GetFlagStatus(I2C1, I2C_ISR_BUSY) != RESET){}; //   
lab1:
	I2C_ClearFlag(I2C1, I2C_ICR_NACKCF); //   NACKCF

	//  : , ,  , ,   
	I2C_TransferHandling(I2C1, AMG_ADDR, 1, I2C_SoftEnd_Mode, I2C_Generate_Start_Write);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET) // ,   TXIS   
	{
		if (I2C_GetFlagStatus(I2C1, I2C_FLAG_NACKF) == SET) // NACK  - 
		{
			while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
			I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
			goto lab1; // 
		}
	}
	I2C_SendData(I2C1, ReadAddr); //   
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TC) == RESET){}; //   TC    

	//  : , ,  1  , 
	I2C_TransferHandling(I2C1, AMG_ADDR, 1, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);

	while(I2C_GetFlagStatus(I2C1, I2C_ISR_RXNE) == RESET){}; // ,   RXNE   
	data = I2C_ReceiveData(I2C1); //  
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
	I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
	return data;
}


/////////////////////////////    ///////////////////////////////////////////
void Amg88xx_Write(uint8_t WriteAddr, uint8_t data)
{
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_BUSY) != RESET){}; //   
lab1:
	I2C_ClearFlag(I2C1, I2C_ICR_NACKCF); //   NACKCF
	//  : , ,  2  ,   
	I2C_TransferHandling(I2C1, AMG_ADDR, 2, I2C_AutoEnd_Mode, I2C_Generate_Start_Write);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET) // ,   TXIS   
	{
		if (I2C_GetFlagStatus(I2C1, I2C_FLAG_NACKF) == SET) // NACK  - 
		{
			while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
			I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
			goto lab1; // 
		}
	}

	I2C_SendData(I2C1, WriteAddr); //  
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET){}; // ,   TXIS   
	I2C_SendData(I2C1, data); // 
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF   
	I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
}

