/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "HW_Configs.h"
#include "stm32f30x_it.h"
#include "tft_ili9341a.h"
#include "amg88xx.h"

//   ------------------------------------------------------


//   -----------------------------------------------------------
int16_t AmgArray[64]; //     ( ,    0.1`)
uint8_t Amg88Index;
uint16_t PixArray[57][57]; //   (_*16 ,       ( ))
uint16_t Akk0[57][57]; //   
uint16_t Akk1[57][57]; //   

char str[32] = "";
uint32_t CounterBeep;
uint32_t BLCounter;
uint32_t Flags;
uint8_t Scale, Palette;

//   ----------------------------------------
int16_t TMax,TMin;
int16_t TMax_tmp,TMin_tmp;
int16_t T_Cen;
int32_t Xx,Yy,Zz,Ss = 0;
float Ff;

//    ----------------------------------------
int32_t FilterTCenRC(int32_t Sample);
uint32_t FilterKatRC(uint32_t Sample);
uint16_t ColorScale93(uint16_t Val);

////////////////////////////////   /////////////////////////////////////////
int main(void)
{
//-------------------------------------------------------------------------------------
//    startup_stm32f0xx.s. 
//	 stm32f0xx.h  -  ,   ,  .
//	 system_stm32f0xx.c :
//		SystemInit() -  HSI,  .
//		SetSysClock() -   HSE.   ?
//-------------------------------------------------------------------------------------

	__disable_irq();

	SYS_Config(); // ,   
	GPIO_Config(); //  
	NVIC_Config(); //   
	ADC_Config();
	TIM_Config(); // 
	I2C_Config();

	POWER_OFF();
	BEEP_OFF();

	Delay_ms(800);
	if (K_POWER_GET()) {while (1){};}; //   
	POWER_LOCK(); //  - 
	BEEP_ON();
	Delay_ms(100);
	BEEP_OFF();
	while (!K_POWER_GET()) {} //   

	TFT_Init(3); //  
	TFT_ClearScreen(BLACK);

	BL_TIM_PWM = 12000; //  
	BLCounter = BUCKLIGHT; //   

	//   (114114) 2,2 - 115,115
	TFT_DrawHorizontalLine(0, 0, 117, BRIGHTGREEN); //  
	TFT_DrawVerticalLine(0, 0, 117, BRIGHTGREEN);
	TFT_DrawHorizontalLine(0, 117, 117, BRIGHTGREEN);
	TFT_DrawVerticalLine(117, 0, 117, BRIGHTGREEN);

	//   (114114) 2,124 - 115,237
	TFT_DrawHorizontalLine(0, 239-117, 117, BRIGHTGREEN); //  
	TFT_DrawVerticalLine(0, 239-117, 117, BRIGHTGREEN);
	TFT_DrawHorizontalLine(0, 239, 117, BRIGHTGREEN);
	TFT_DrawVerticalLine(117, 239-117, 117, BRIGHTGREEN);
	TFT_DrawString("><", 3*9, 11*16, 0, RED);

	TFT_DrawString("", 30*9, 0*16, 0, BRIGHTCYAN);
	TFT_DrawString("", 30*9, 1*16, 0, CYAN);

	TFT_DrawString(":", 27*9, 5*16, 0, GRAY096);

	TFT_DrawString("0", 24*9, 8*16, 0, BRIGHTYELLOW);
	TFT_DrawString("ver0.4", 26*9, 9*16, 0, GREEN);
	TFT_DrawString("a_biv@list.ru", 22*9+4, 10*16, 0, SIENNA);

	TFT_DrawString(": ", 24*9, 13*16, 0, BRIGHTCYAN);
	TFT_DrawString(" ", 30*9, 14*16, 0, CYAN);

	TFT_DrawHorizontalLine(124, 117, 65, BRIGHTGREEN); //  
	TFT_DrawHorizontalLine(124, 239-117, 65, BRIGHTGREEN);
	TFT_DrawVerticalLine(195, 5, 239-10, BRIGHTGREEN);

	TFT_DrawCircle(20*9+5, 10, 2, YELLOW);
	TFT_DrawCircle(20*9+5, 41, 2, YELLOW);
	TFT_DrawCircle(20*9+5, 73, 2, YELLOW);
	TFT_DrawCircle(20*9+5, 99, 2, YELLOW);

	TFT_DrawChar('0', 19*9, 7+122, 0, YELLOW);
	TFT_DrawChar('0', 19*9, 38+122, 0, YELLOW);
	TFT_DrawChar('0', 19*9, 70+122, 0, YELLOW);
	TFT_DrawChar('0', 19*9, 96+122, 0, YELLOW);
	TFT_DrawCircle(20*9+5, 10+122, 2, YELLOW);
	TFT_DrawCircle(20*9+5, 41+122, 2, YELLOW);
	TFT_DrawCircle(20*9+5, 73+122, 2, YELLOW);
	TFT_DrawCircle(20*9+5, 99+122, 2, YELLOW);

	TFT_DrawCircle(28*9+4, 35, 2, YELLOW);
	TFT_DrawHorizontalLine(220, 17, 15, YELLOW); // 
	TFT_DrawVerticalLine(227, 10, 15, YELLOW);

	for (Xx=0; Xx<=93; Xx++) TFT_DrawHorizontalLine(128, (93-Xx)+15, 20, ColorScale93(Xx)); //   
	for (Xx=0; Xx<=93; Xx++) TFT_DrawHorizontalLine(128, (93-Xx)+15+122, 20, ColorScale93(Xx)); //   

	for (Xx=0; Xx<=57; Xx++) for (Yy=0; Yy<=57; Yy++) PixArray[Xx][Yy] = 0; //  

	Scale = 0;
	__enable_irq();

	while (1)
	{
		if (Flags & BIT(FRESH100)) //   AMG8833  ---------------------------------------------------
		{
			Flags &= ~BIT(FRESH100); //  

			if (Amg88Index == 0) // AMG8833 
			{
				if (!(Flags & BIT(PAUSE))) // 
				{
					Amg88Index = 1;
					Amg88xx_StartReadInt(); //   AMG8833    (400)
				}
			}
			else if (Amg88Index >= 129) //  AMG8833  
			{
PIN_TEST2_ON();
				TMax_tmp = -600; //   
				TMin_tmp = 2000; //   
				for (Xx=0; Xx<=63; Xx++) //    0.1`C,       
				{
					if (AmgArray[Xx] & 0x800) AmgArray[Xx] = (0x1000 - AmgArray[Xx])* -1;
					AmgArray[Xx] = (AmgArray[Xx]*2)+(AmgArray[Xx]/2); // *2.5   1  - 0.1`C

					if (AmgArray[Xx] > 1250) AmgArray[Xx] = 1250;
					if (AmgArray[Xx] < -550) AmgArray[Xx] = -550;

					if (AmgArray[Xx] >= TMax_tmp) TMax_tmp = AmgArray[Xx]; //  
					if (AmgArray[Xx] <= TMin_tmp) TMin_tmp = AmgArray[Xx]; //  
				}

				Flags &= ~BIT(OVERLOAD); //  
				if (Scale == 0) //   
				{
					//  
					TMax = ((TMax_tmp/20)+1)*20; //  2 
					if (TMin_tmp >= 0) TMin = (TMin_tmp/20)*20; //  2 
					else
					{
						TMin_tmp *= -1;
						TMin = (TMin_tmp/20+1)*20;
						TMin *= -1;
					}
					if (TMax > 1250) TMax = 1250; //    
					if (TMin < -550) TMin = -550; //    
					if (TMax == TMin) //    3 ( )
					{
						if (TMax == 1250) TMin -= 30; 
						else TMax += 30;
					}
				}
				else //  
				{
					for (Xx=0; Xx<=63; Xx++) //    0.1`C,       
					{
						if (AmgArray[Xx] > TMax) {AmgArray[Xx] = TMax; Flags |= BIT(OVERLOAD);}
						if (AmgArray[Xx] < TMin) {AmgArray[Xx] = TMin; Flags |= BIT(OVERLOAD);}
					}
				}

				T_Cen = FilterTCenRC(AmgArray[27]); //   

				for (Xx=0; Xx<=63; Xx++) //   88    5757 *16 (0...1488) (  )
					//      *16 (0...1488)
					PixArray[56-((Xx&0x07)*8)][56-(((Xx>>3)&0x07)*8)] = ((16*93)*(AmgArray[Xx]-TMin))/(TMax-TMin);

				Amg88Index = 0; //    ,     

				//  
				sprintf(str, "%3i", TMax/10);
				TFT_DrawString(str, 17*9, 7, 0, YELLOW);
				sprintf(str, "%3i", (TMax-((TMax-TMin)/3))/10);
				TFT_DrawString(str, 17*9, 38, 0, YELLOW);
				sprintf(str, "%3i", (((TMax-TMin)/3)+TMin)/10);
				TFT_DrawString(str, 17*9, 70, 0, YELLOW);
				sprintf(str, "%3i", TMin/10);
				TFT_DrawString(str, 17*9, 96, 0, YELLOW);

				if (T_Cen < 0) {T_Cen *= -1; TFT_DrawChar('-', 23*9, 2*16, 0, YELLOW);}
				else TFT_DrawChar('+', 23*9, 2*16, 0, YELLOW);
				sprintf(str, "%2i.%1i", T_Cen/10, T_Cen%10);
				TFT_DrawString(str, 24*9, 2*16, 0, YELLOW);

				Flags |= BIT(REDRAW); //   
			}
		}

		if (Flags & BIT(REDRAW)) //    ----------------------------------
		{
			Flags &= ~BIT(REDRAW); //  

			//   
			for (Xx=0; Xx<=56; Xx+=8) //       
			for (Yy=0; Yy<=48; Yy+=8) //       
			{
				//    
				PixArray[Xx][Yy+4] = (PixArray[Xx][Yy  ] + PixArray[Xx][Yy+8])/2;
				PixArray[Xx][Yy+2] = (PixArray[Xx][Yy  ] + PixArray[Xx][Yy+4])/2;
				PixArray[Xx][Yy+1] = (PixArray[Xx][Yy  ] + PixArray[Xx][Yy+2])/2;
				PixArray[Xx][Yy+3] = (PixArray[Xx][Yy+2] + PixArray[Xx][Yy+4])/2;
				PixArray[Xx][Yy+6] = (PixArray[Xx][Yy+4] + PixArray[Xx][Yy+8])/2;
				PixArray[Xx][Yy+5] = (PixArray[Xx][Yy+4] + PixArray[Xx][Yy+6])/2;
				PixArray[Xx][Yy+7] = (PixArray[Xx][Yy+6] + PixArray[Xx][Yy+8])/2;
			}
			for (Xx=0; Xx<=48; Xx+=8) //      
			for (Yy=0; Yy<=56; Yy++) //     
			{
				PixArray[Xx+4][Yy] = (PixArray[Xx  ][Yy] + PixArray[Xx+8][Yy])/2;
				PixArray[Xx+2][Yy] = (PixArray[Xx  ][Yy] + PixArray[Xx+4][Yy])/2;
				PixArray[Xx+1][Yy] = (PixArray[Xx  ][Yy] + PixArray[Xx+2][Yy])/2;
				PixArray[Xx+3][Yy] = (PixArray[Xx+2][Yy] + PixArray[Xx+4][Yy])/2;
				PixArray[Xx+6][Yy] = (PixArray[Xx+4][Yy] + PixArray[Xx+8][Yy])/2;
				PixArray[Xx+5][Yy] = (PixArray[Xx+4][Yy] + PixArray[Xx+6][Yy])/2;
				PixArray[Xx+7][Yy] = (PixArray[Xx+6][Yy] + PixArray[Xx+8][Yy])/2;
			}

			//   
			for (Xx=0; Xx<=56; Xx++) for (Yy=0; Yy<=56; Yy++) //  
			{
				Zz = PixArray[Xx][Yy];
				PixArray[Xx][Yy] += Akk0[Xx][Yy] + Akk1[Xx][Yy];
				PixArray[Xx][Yy] /= 3;

				Akk1[Xx][Yy] = Akk0[Xx][Yy]; //  
				Akk0[Xx][Yy] = Zz;
			}

			//   *16   
			for (Xx=0; Xx<=56; Xx++) for (Yy=0; Yy<=56; Yy++)
			{
				PixArray[Xx][Yy] = ColorScale93(PixArray[Xx][Yy]/16);
			}

			for (Xx=29; Xx<=35; Xx++) //   
			{
				PixArray[Xx][32] ^= 0xFFFF;
				PixArray[32][Xx] ^= 0xFFFF;
			}

			TFT_DrawPic(); //     
PIN_TEST2_OFF();
		}

		if (Flags & BIT(FRESH300)) //      ----------------------------------
		{
			Flags &= ~BIT(FRESH300); //  

			Flags ^= BIT(OVFLASH); //  
			if ((Flags & (BIT(OVERLOAD)))&&(Flags & (BIT(OVFLASH)))) TFT_DrawString(" !", 24*9, 4*16-8, 0, BRIGHTRED);
			else TFT_DrawString("          ", 24*9, 4*16-8, 0, BRIGHTRED);

			if (ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC) == SET) //  
			{
				Xx = (ADC_GetConversionValue(ADC1) * 6704)/4096;
				Xx = FilterKatRC(Xx);

				sprintf(str, "%4umV", Xx);
				TFT_DrawString(str, 24*9, 6*16, 0, GRAY054);
				// 3.4V -> 0%,  4.2V -> 100%
				if (Xx < 3330) Xx = 0;
				else if (Xx > 4200) Xx = 100;
				else
				{
					Xx -= 3330; // 3330..4200 -> 0..870
					Xx = (Xx*10)/87; // 0..870 -> 0..100
				}
				sprintf(str, "%3u%%", Xx);
				if (Xx < 15) TFT_DrawString(str, 31*9, 6*16, 0, BRIGHTRED);
				else TFT_DrawString(str, 31*9, 6*16, 0, WHITE);
			}
		}

		if (Flags & BIT(KEY_S_PR)) //  ""  /  ( ) -----------------------
		{
			Flags &= ~BIT(KEY_S_PR); //  
			CounterBeep = 30; // 
			if (BL_TIM_PWM == 12000) //     
			{
				if (Flags & BIT(PAUSE))
				{
					TFT_DrawString("", 30*9, 0*16, 0, BRIGHTCYAN);
					Flags &= ~BIT(PAUSE);
				}
				else
				{
					TFT_DrawString("", 30*9, 0*16, 0, BRIGHTCYAN);
					Flags |= BIT(PAUSE);
				}
			}
			BLCounter = BUCKLIGHT; //    30 
			BL_TIM_PWM = 12000; //  
		}

		if (Flags & BIT(KEY_P_PR)) //  "Power"   ---------------------------------------------------
		{
			Flags &= ~BIT(KEY_P_PR); //  
			CounterBeep = 30; // 
			if (BL_TIM_PWM == 12000) //     
			{
				Scale++;
				switch(Scale)
				{
				case 1: //  
					TFT_DrawString("     ", 30*9, 12*16, 0, BRIGHTCYAN);
					TFT_DrawString(" ", 30*9, 13*16, 0, BRIGHTCYAN);
					break;
				case 2: // 
					TMax = 400;
					TMin = 160;
					TFT_DrawString(" 40`C", 30*9, 12*16, 0, BRIGHTCYAN);
					TFT_DrawString(" 16`C", 30*9, 13*16, 0, BRIGHTCYAN);
					break;
				case 3: // 
					TMax = 800;
					TMin = -50;
					TFT_DrawString(" 80`C", 30*9, 12*16, 0, BRIGHTCYAN);
					TFT_DrawString(" -5`C", 30*9, 13*16, 0, BRIGHTCYAN);
					break;
				default: //   
					TFT_DrawString("     ", 30*9, 12*16, 0, BRIGHTCYAN);
					TFT_DrawString(" ", 30*9, 13*16, 0, BRIGHTCYAN);
					Scale = 0;
					break;
				}
			}
			BLCounter = BUCKLIGHT; //    30 
			BL_TIM_PWM = 12000; //  
		}

		if (Flags & BIT(KEY_D_UD)) //  ""+"Power"  ------------------------------------------
		{
			Flags &= ~BIT(KEY_D_UD); //  
			CounterBeep = 30; // 
			BLCounter = BUCKLIGHT; //    30 
			BL_TIM_PWM = 12000; //  

			Palette++; //  
			if (Palette > 5) Palette = 0;

			for (Xx=0; Xx<=93; Xx++) TFT_DrawHorizontalLine(128, (93-Xx)+15, 20, ColorScale93(Xx)); //   
		}

		if (Flags & BIT(KEY_S_UD)) //  ""       --------------------
		{
			Flags &= ~BIT(KEY_S_UD); //  
			CounterBeep = 30; // 
			BLCounter = BUCKLIGHT; //    30 
			BL_TIM_PWM = 12000; //  

			for (Xx=29; Xx<=35; Xx++) //   
			{
				PixArray[Xx][32] ^= 0xFFFF;
				PixArray[32][Xx] ^= 0xFFFF;
			}

			for (Xx=0; Xx<=56; Xx++) for (Yy=0; Yy<=56; Yy++) //        
			{
				TFT_SetPixelExt(2*Xx+2, 2*Yy+124, PixArray[Xx][Yy]); //    - 22
				TFT_SetPixelExt(2*Xx+2, 2*Yy+125, PixArray[Xx][Yy]);
				TFT_SetPixelExt(2*Xx+3, 2*Yy+124, PixArray[Xx][Yy]);
				TFT_SetPixelExt(2*Xx+3, 2*Yy+125, PixArray[Xx][Yy]);
			}

			//    
			sprintf(str, "%3i", TMax/10);
			TFT_DrawString(str, 17*9, 7+122, 0, YELLOW);
			sprintf(str, "%3i", (TMax-((TMax-TMin)/3))/10);
			TFT_DrawString(str, 17*9, 38+122, 0, YELLOW);
			sprintf(str, "%3i", (((TMax-TMin)/3)+TMin)/10);
			TFT_DrawString(str, 17*9, 70+122, 0, YELLOW);
			sprintf(str, "%3i", TMin/10);
			TFT_DrawString(str, 17*9, 96+122, 0, YELLOW);

			for (Xx=0; Xx<=93; Xx++) TFT_DrawHorizontalLine(128, (93-Xx)+15+122, 20, ColorScale93(Xx)); //   
		}

		if (Flags & BIT(KEY_P_UD)) //  "Power"  ----------------------------------------
		{
			__disable_irq();
			BEEP_ON();
			POWER_OFF();
			BL_TIM_PWM = 0; //  
			Delay_ms(100);
			BEEP_OFF();
			while (1) {}
		}

#ifdef W_DOG			//  
		IWDG_ReloadCounter(); //  
#endif
	}
}


/////////////   0...93   /////////////////////////////////////
uint16_t ColorScale93(uint16_t Val)
{
	uint16_t a;
	if (Val > 93) Val = 93;

	switch (Palette)
	{
	case 1: // 0-, 31--, 62--, 93-
		a = 0;
		if (Val <= 62) a = (62-Val)/2; // B
		if (Val >= 32) a |= ((Val-32)/2)<<11; // R
		break;
	case 2: // 0-, 46-, 93-
		a = 0;
		if (Val >= 47) a = (((uint32_t)(Val-47)*674)/1000)<<6; // G
		if (Val <= 46) a |= (((46-Val)*674)/1000); else a |= (((Val-47)*674)/1000); // B
		if (Val <= 46) a |= ((Val*674)/1000)<<11; else a |= 0x1F<<11;// R
		break;
	case 3:	// 0-, 23-, 46-, 71-, 93-
		a = 0;
		if (Val >= 71) a |= ((((Val-70)*135)/100)<<6) | (((Val-70)*135)/100); // G + B
		if (Val >= 71) a |= 0xF800; else if (Val >= 47) a |= (((Val-47)*135)/100)<<11;  // R
		if (Val <= 23) a |= ((Val*135)/100); else if (Val <= 46) a |= (((22-(Val-24))*136)/100); // B
		if ((Val >= 23)&&(Val <= 70)) {if ((Val <= 46)) a |= (((Val-23)*135)/100)<<6; else a |= (((23-(Val-47))*135)/100)<<6;} // G
		break;
	case 4: //  
		switch (Val/9) // 0..10
		{
			case 1: a = BLUE; break;
			case 2: a = BRIGHTBLUE; break;
			case 3: a = CYAN; break;
			case 4: a = GREEN; break;
			case 5: a = MAGENTA; break;
			case 6: a = SADDLEBROWN; break;
			case 7: a = HIRED; break;
			case 8: a = ORANGE; break;
			case 9: a = YELLOW; break;
			case 10: a = WHITE; break;
			default: a = GRAY054; break;
		}
		break;
	case 5: //  
		a = ((Val/3)<<11) | (((Val+1)/3)<<6) | ((Val+2)/3);
		break;
	default: // 0-, 31-, 62-, 93-
		if (Val >= 63) a = 0xF800 | ((Val-62)<<6) | (Val-62);
		else if (Val >= 32) a = (((Val-31)<<11)&0xF800) | (30-(Val-32));
		a |= 0x60;
		break;
	}
	return a;
}


///////////// RC-  //////////////////////////////////////////////
int32_t FilterTCenRC(int32_t Sample)
{
	static int32_t Akk0 = 0, Akk1 = 0;

	Akk0 = Sample+(Akk0/2);
	Akk1 = (Akk0/2)+(Akk1/2);

	return (Akk1/2);
}


///////////// RC-  //////////////////////////////////////////////
uint32_t FilterKatRC(uint32_t Sample) // (2 ) 1.5@72 STM32F3
{
	static uint32_t Akk0 = 0, Akk1 = 0;

	if (Akk0 < 1000) Akk0 = Akk1 = Sample<<3; //  

	Akk0 =  Sample  +((Akk0*7)>>3);
	Akk1 = (Akk0>>3)+((Akk1*7)>>3);

	return (Akk1>>3);
}


////////////    //////////////////////////////////////////////
void Delay_ms(uint32_t ms)
{
	ms *= SystemCoreClock / 6950u; //   
	while (ms-- != 0) {__asm(" nop");}
}


/////////////////////////////////////////////////////////////////////////////////
#ifdef  USE_FULL_ASSERT 
void assert_failed(uint8_t* file, uint32_t line){
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

	TFT_DrawString("ASSERT !!", 194, 70, 1, BRIGHTRED);

	while (1)  {  }
}
#endif
