#ifndef __MAIN_H /* Define to prevent recursive inclusion --------------------*/
#define __MAIN_H
#ifdef __cplusplus
 extern "C" {
#endif

//#define USE_FULL_ASSERT	// ,    

/* Main Includes ------------------------------------------------------------------*/
#include "stm32f30x.h"
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
//#include <math.h>

//   -------------------------------------------------------------
#define _BITSET(bits) ((uint16_t)((bits % 010) | (bits / 010 % 010) << 1 | (bits / 0100 % 010) << 2 | \
  (bits / 01000 % 010) << 3 | (bits / 010000 % 010) << 4 | (bits / 0100000 % 010) << 5 | (bits / 01000000 % 010) << 6 | \
  (bits / 010000000 % 010) << 7 | (bits / 0100000000 % 010) << 8 | (bits / 01000000000 % 010) << 9 | (bits / 010000000000 % 010) << 10 | \
  (bits / 0100000000000 % 010) << 11 | (bits / 01000000000000 % 010) << 12 | (bits / 010000000000000 % 010) << 13 | \
  (bits / 0100000000000000 % 010) << 14 | (bits / 01000000000000000 % 010) << 15))
#define BIN(bits) _BITSET(0##bits)	// : BIN(111001100110)

#define BIT(n) (1UL<<(n))	// : BIT(2)|BIT(0) == 0b101 == 0x5
typedef enum {FALSE = 0, TRUE = !FALSE} bool;

//   -----------------------------------------------------
#define NODEBUG			//    FLASH
//#define W_DOG			//  

//  ------------------------------------------------------------
#define	KDEBOUNCE		25
#define	KUPRESS			900
#define	BUCKLIGHT		(3*1000*60)

#define	BL_TIM_PWM		(TIM17->CCR1)

#define K_POWER_GET()	(GPIOA->IDR & GPIO_Pin_10)
#define K_STOP_GET()	(GPIOA->IDR & GPIO_Pin_9)

#define INT_AMG8833_GET()	(GPIOB->IDR & GPIO_Pin_10)

#define POWER_LOCK()	(GPIOA->BSRR = GPIO_Pin_8)
#define POWER_OFF()		(GPIOA->BRR = GPIO_Pin_8)

#define BEEP_ON()		(GPIOA->BSRR = GPIO_Pin_6)
#define BEEP_OFF()		(GPIOA->BRR = GPIO_Pin_6)

#define PIN_TEST2_ON()	(GPIOA->BSRR = GPIO_Pin_1)
#define PIN_TEST2_OFF()	(GPIOA->BRR = GPIO_Pin_1)
#define PIN_TEST1_TOG() (GPIOA->ODR ^= GPIO_Pin_2)
#define PIN_TEST3_ON()	(GPIOA->BSRR = GPIO_Pin_3)
#define PIN_TEST3_OFF()	(GPIOA->BRR = GPIO_Pin_3)
#define PIN_TEST3_TOG() (GPIOA->ODR ^= GPIO_Pin_3)
#define PIN_TEST4_TOG() (GPIOA->ODR ^= GPIO_Pin_4)
#define PIN_TEST5_TOG() (GPIOA->ODR ^= GPIO_Pin_5)
#define PIN_TEST6_TOG() (GPIOB->ODR ^= GPIO_Pin_11)


#define DELAY_US(x)		{\
	uint32_t _dcnt;\
	_dcnt = x;\
	_dcnt *= SystemCoreClock / 8000000;\
	while (_dcnt-- != 0) {__asm(" nop");}}

enum Refresh {OVFLASH,OVERLOAD,PAUSE,REDRAW,FRESH100,FRESH300,KEY_P_PR,KEY_P_UD,KEY_S_PR,KEY_D_PR,KEY_S_UD,KEY_D_UD};

//    ----------------------------------------
void Delay_ms(uint32_t ms);

#ifdef __cplusplus
}
#endif
#endif /* __MAIN_H */
