// 

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f30x_it.h"

//   ------------------------------------------------------
extern uint32_t CounterBeep;
extern uint32_t BLCounter;
extern uint32_t Flags;
extern int16_t AmgArray[];
extern uint8_t Amg88Index;

//   -----------------------------------------------------------

//    ----------------------------------------
void NMI_Handler(void);
void HardFault_Handler(void);
void MemManage_Handler(void);
void BusFault_Handler(void);
void UsageFault_Handler(void);
void SVC_Handler(void);
void DebugMon_Handler(void);
void PendSV_Handler(void);
void SysTick_Handler(void);


/******************************************************************************/
/*            Cortex-M0 Processor Exceptions Handlers                         */
/******************************************************************************/

// @brief  This function handles NMI exception.
void NMI_Handler(void)
{

}

// @brief  This function handles Hard Fault exception.
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

// @brief  This function handles Memory Manage exception.
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

// @brief  This function handles Bus Fault exception.
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

// @brief  This function handles Usage Fault exception.
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

// @brief  This function handles SVCall exception.
void SVC_Handler(void)
{
}

// @brief  This function handles Debug Monitor exception.
void DebugMon_Handler(void)
{
}

// @brief  This function handles PendSVC exception.
void PendSV_Handler(void)
{
}

// @brief  This function handles SysTick Handler.
void SysTick_Handler(void)
{
	static uint32_t Timer100ms, Timer300ms;
	static uint32_t Counter_P = 0, Counter_S = 0, Counter_D = 0;

	if (K_POWER_GET()==0) { //   -------------------------------------------------------------
		if (Counter_P < 5000) Counter_P++;
		if (Counter_P == KUPRESS) Flags |= BIT(KEY_P_UD);  // 
	} else { // 
		if ((Counter_P > KDEBOUNCE)&&(Counter_P < KUPRESS)) Flags |= BIT(KEY_P_PR); //   
		Counter_P = 0;
	}
	if (K_STOP_GET()==0) { //   -------------------------------------------------------------
		if (Counter_S < 5000) Counter_S++;
		if (Counter_S == KUPRESS) Flags |= BIT(KEY_S_UD);  // 
	} else { // 
		if ((Counter_S > KDEBOUNCE)&&(Counter_S < KUPRESS)) Flags |= BIT(KEY_S_PR); //   
		Counter_S = 0;
	}
	if ((K_POWER_GET()==0)&&(K_STOP_GET()==0)) { //    -------------------------------------------------------------
		if (Counter_D < 5000) Counter_D++;
		if (Counter_D == KUPRESS) Flags |= BIT(KEY_D_UD);  // 
		Counter_P = 0;
		Counter_S = 0;
	} else { //    
		if (Counter_D != 0) { //   
			Counter_P = 0;
			Counter_S = 0;//   
			if ((K_POWER_GET()!=0)&&(K_STOP_GET()!=0)) { //  
				if ((Counter_D > KDEBOUNCE)&&(Counter_D < KUPRESS)) Flags |= BIT(KEY_D_PR); //   
				Counter_D = 0;
			}
		}
	}

	Timer100ms++;
	if (Timer100ms >= 100) 
	{
		Flags |= BIT(FRESH100); //  
		Timer100ms = 0;
	}

	Timer300ms++;
	if (Timer300ms >= 300) 
	{
		Flags |= BIT(FRESH300); //  
		Timer300ms = 0;
	}

	if (CounterBeep != 0)
	{
		if (CounterBeep == 1) BEEP_OFF();
		else BEEP_ON();
		CounterBeep--;
	}

	if (BLCounter != 0) 
	{
		if (BLCounter == 1) BL_TIM_PWM = 3000; //  
		BLCounter--;
	}
	PIN_TEST1_TOG();
}


/******************************************************************************/
/*                 STM32F30x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f30x.s).                                               */
/******************************************************************************/
void I2C1_EV_IRQHandler(void)
{
	if (I2C_GetITStatus(I2C1, I2C_IT_RXNE)) //  
	{
		if ((Amg88Index & 0x01)!= 0) AmgArray[(Amg88Index-1)/2] = I2C_ReceiveData(I2C1); //  
		else AmgArray[(Amg88Index-1)/2] |= (uint16_t)I2C_ReceiveData(I2C1)<<8; //  

		Amg88Index++;
		if (Amg88Index >= 129) //   
		{
			while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET){}; // ,   STOPF    (40)
			I2C_ClearFlag(I2C1, I2C_ICR_STOPCF); //   STOPF
			I2C_ITConfig(I2C1, I2C_IT_RXI, DISABLE); //     
		}
	}
}














