/* Created: 14.10.2013 12:47:54  Author: Ovner */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "tft_ili9341a.h"
#include "fonts.h"

#ifndef DISP_X_OFFSET
#define DISP_X_OFFSET 0
#endif

#ifndef DISP_Y_OFFSET
#define DISP_Y_OFFSET 0
#endif

//   -----------------------------------------------------------
uint16_t Max_X = 0, Max_Y = 0;

//    ----------------------------------------
uint16_t constrain(uint16_t a, uint16_t b, uint16_t c);
void TFT_SendCMD(uint8_t cmd);
void TFT_WriteData(uint8_t data);
uint8_t TFT_ReadData(void);
void __forceinline TFT_SendData(uint16_t data);
uint16_t bg_color = BLACK;
uint8_t flag_bg_transparence = 0; //   

//  ==================================================================

uint16_t constrain(uint16_t a, uint16_t b, uint16_t c) {
    if (a < b) return b;
    if (c < a) return c;
    return a;
}

//  -----------------------------------------------------------------

void TFT_SendCMD(uint8_t cmd) {
    TFT_WRX_LO;
//    TFT_RDX_HI;
    TFT_RSX_LO;
    TFT_CSX_LO;
    TFT_DATA_PORT(cmd);
    TFT_WRX_HI;
    TFT_CSX_HI;
    TFT_RSX_HI;
}

//  -----------------------------------------------------------------

void TFT_WriteData(uint8_t data) {
    TFT_WRX_LO;
    //TFT_RDX_HI;
    //TFT_RSX_HI;
    TFT_CSX_LO;
    TFT_DATA_PORT(data);
    TFT_WRX_HI;
    TFT_CSX_HI;
    //TFT_RSX_HI;
}

//  -----------------------------------------------------------------

uint8_t TFT_ReadData(void) {
    uint8_t data;

    TFT_WRX_HI;
    TFT_DATA_IN(); //  
    TFT_CSX_LO;
    TFT_RSX_HI;
    TFT_RDX_LO;
    __nop(); //  Nop`   ,  
    data = TFT_DATA_PORT_IN;
    TFT_RDX_HI;
    TFT_CSX_HI;
    TFT_DATA_OUT(); //  

    return data;
}

//  -----------------------------------------------------------------

void __forceinline TFT_SendData(uint16_t data) {
    //    uint8_t data1 = data >> 8;
    //    uint8_t data2 = data & 0xff;
    //
    //    TFT_WriteData(data1);
    //    TFT_WriteData(data2);

    //  :        
    TFT_CSX_LO;
    TFT_WRX_LO;
    TFT_DATA_PORT(data >> 8);
    TFT_WRX_HI;

    TFT_WRX_LO;
    TFT_DATA_PORT(data & 0xff);
    TFT_WRX_HI;
    TFT_CSX_HI;
}

//  -----------------------------------------------------------------

void TFT_Init(uint8_t orient) {

    TFT_CSX_HI;
    TFT_RESX_LO;
    TFT_RDX_HI;
    TFT_DATA_OUT(); //  
    TFT_DATA_PORT(0);

	//    
   Delay_ms(20);
    TFT_RESX_HI;
    Delay_ms(20);

    TFT_SendCMD(0x01);
    Delay_ms(10);

    //************* Start Initial Sequence **********//
    //Power control A
    TFT_SendCMD(0xCB);
    TFT_WriteData(0x39);
    TFT_WriteData(0x2C);
    TFT_WriteData(0x00);
    TFT_WriteData(0x34);
    TFT_WriteData(0x02);


    //Power control A
    TFT_SendCMD(0xCF);
    TFT_WriteData(0x00);
    TFT_WriteData(0XC1);
    TFT_WriteData(0X30);


    //Driver timing control A
    TFT_SendCMD(0xE8);
    TFT_WriteData(0x85);
    TFT_WriteData(0x00);
    TFT_WriteData(0x78);


    //Driver timing control B
    TFT_SendCMD(0xEA);
    TFT_WriteData(0x00);
    TFT_WriteData(0x00);


    //Power on sequence control
    TFT_SendCMD(0xED);
    TFT_WriteData(0x64);
    TFT_WriteData(0x03);
    TFT_WriteData(0X12);
    TFT_WriteData(0X81);


    //Pump ratio control
    TFT_SendCMD(0xF7);
    TFT_WriteData(0x20);


    //Power Control 1
    TFT_SendCMD(0xC0);
    TFT_WriteData(0x23);


    //Power Control 2
    TFT_SendCMD(0xC1);
    TFT_WriteData(0x10);


    //VCOM Control 1
    TFT_SendCMD(0xC5);
    TFT_WriteData(0x2B);
    TFT_WriteData(0x2B);


    //Memory Access Control
    TFT_SetOrientation(orient);

    //Frame Rate Control (In Normal Mode/Full Colors)
    TFT_SendCMD(0xB1);
    TFT_WriteData(0x00);
    TFT_WriteData(0x1B);


    //Display Function Control
    TFT_SendCMD(0xB6);
    TFT_WriteData(0x0A);
    TFT_WriteData(0x02);


    //Enable 3G
    TFT_SendCMD(0xF2);
    TFT_WriteData(0x02);


    //COLMOD: Pixel Format Set
    TFT_SendCMD(0x3a);
    TFT_WriteData(0x05);


    //Gamma Set
    TFT_SendCMD(0x26);
    TFT_WriteData(0x01);

    TFT_SendCMD(0x21);


    //Positive Gamma Correction
    TFT_SendCMD(0xE0);
    TFT_WriteData(0x0F);
    TFT_WriteData(0x31);
    TFT_WriteData(0x2B);
    TFT_WriteData(0x0C);
    TFT_WriteData(0x0E);
    TFT_WriteData(0x08);
    TFT_WriteData(0x4E);
    TFT_WriteData(0xF1);
    TFT_WriteData(0x37);
    TFT_WriteData(0x07);
    TFT_WriteData(0x10);
    TFT_WriteData(0x03);
    TFT_WriteData(0x0E);
    TFT_WriteData(0x09);
    TFT_WriteData(0x00);


    //Negative Gamma Correction
    TFT_SendCMD(0XE1);
    TFT_WriteData(0x00);
    TFT_WriteData(0x0E);
    TFT_WriteData(0x14);
    TFT_WriteData(0x03);
    TFT_WriteData(0x11);
    TFT_WriteData(0x07);
    TFT_WriteData(0x31);
    TFT_WriteData(0xC1);
    TFT_WriteData(0x48);
    TFT_WriteData(0x08);
    TFT_WriteData(0x0F);
    TFT_WriteData(0x0C);
    TFT_WriteData(0x31);
    TFT_WriteData(0x36);
    TFT_WriteData(0x0F);

    // Sleep Out
    TFT_SendCMD(0x11);

    //delayMs(120);
    Delay_ms(10);

    //Display On
    TFT_SendCMD(0x29);
}

//  -----------------------------------------------------------------

void __forceinline TFT_SetCol(uint16_t StartCol, uint16_t EndCol) {
    TFT_SendCMD(0x2A); /* Column Command address       */
    TFT_SendData(StartCol);
    TFT_SendData(EndCol);
}

//  -----------------------------------------------------------------

void __forceinline TFT_SetPage(uint16_t StartPage, uint16_t EndPage) {
    TFT_SendCMD(0x2B); /* Column Command address       */
    TFT_SendData(StartPage);
    TFT_SendData(EndPage);
}

//  -----------------------------------------------------------------

void TFT_ClearScreen(uint16_t color) {
    uint32_t i = 0;
    uint8_t Hcolor;
    uint8_t Lcolor;

    //color = ~color;

    TFT_SetCol(0, Max_X);
    TFT_SetPage(0, Max_Y);
    TFT_SendCMD(0x2c); /* start to write to display ram */

    TFT_RSX_HI;
    TFT_CSX_LO;
//    TFT_RDX_HI;

    Hcolor = color >> 8;
    Lcolor = color & 0xff;

    for (i = 0; i < 320ul * 240ul / 16; i++) {
        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;
        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;
    }
    TFT_CSX_HI;
}

//  -----------------------------------------------------------------

void TFT_FillArea(uint16_t XL, uint16_t XR, uint16_t YU, uint16_t YD, uint16_t color) {
    static unsigned long XY = 0;
    static unsigned long i = 0;
    //color = ~color;
    uint8_t Hcolor;
    uint8_t Lcolor;

    if (XL > XR) {
        XL = XL^XR;
        XR = XL^XR;
        XL = XL^XR;
    }
    if (YU > YD) {
        YU = YU^YD;
        YD = YU^YD;
        YU = YU^YD;
    }
    XL = constrain(XL, MIN_X, Max_X);
    XR = constrain(XR, MIN_X, Max_X);
    YU = constrain(YU, MIN_Y, Max_Y);
    YD = constrain(YD, MIN_Y, Max_Y);

    XY = (XR - XL + 1);
    XY = XY * (YD - YU + 1);

    TFT_SetCol(XL, XR);
    TFT_SetPage(YU, YD);
    TFT_SendCMD(0x2c); /* start to write to display ram */

    TFT_RSX_HI;
    TFT_CSX_LO;
//    TFT_RDX_HI;

    Hcolor = color >> 8;
    Lcolor = color & 0xff;
    for (i = 0; i < XY; i++) {
        //		TFT_WriteData(Hcolor);
        //		TFT_WriteData(Lcolor);

        TFT_WRX_LO;
        TFT_DATA_PORT(Hcolor);
        TFT_WRX_HI;

        TFT_WRX_LO;
        TFT_DATA_PORT(Lcolor);
        TFT_WRX_HI;
    }
    TFT_CSX_HI;
}

//  -----------------------------------------------------------------

void __forceinline TFT_SetXY(uint16_t poX, uint16_t poY) {
    TFT_SetCol(poX, poX);
    TFT_SetPage(poY, poY);
    TFT_SendCMD(0x2c);
}

//  -----------------------------------------------------------------

void __forceinline TFT_SetPixel(uint16_t poX, uint16_t poY, uint16_t color) {
    TFT_SetXY(poX, poY);
    //	TFT_SendData(~color);
    TFT_SendData(color);
}

void TFT_SetPixelExt(uint16_t poX, uint16_t poY, uint16_t color) {
    TFT_SetXY(poX, poY);
    //	TFT_SendData(~color);
    TFT_SendData(color);
}
//  -----------------------------------------------------------------

void TFT_FillRectangle(uint16_t poX, uint16_t poY, uint16_t length, uint16_t width, uint16_t color) {
    TFT_FillArea(poX, poX + length, poY, poY + width, color);
}

//  -----------------------------------------------------------------

void TFT_DrawHorizontalLine(uint16_t poX, uint16_t poY, uint16_t length, uint16_t color) {
    uint16_t i;

    TFT_SetCol(poX, poX + length);
    TFT_SetPage(poY, poY);
    TFT_SendCMD(0x2c);
    for (i = 0; i < length; i++)
        //	TFT_SendData(~color);
        TFT_SendData(color);
}

//  -----------------------------------------------------------------

void TFT_DrawLine(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color) {

    int x = x1 - x0;
    int y = y1 - y0;
    int dx = abs(x), sx = x0 < x1 ? 1 : -1;
    int dy = -abs(y), sy = y0 < y1 ? 1 : -1;
    int err = dx + dy, e2; /* error value e_xy             */

    for (;;) { /* loop                         */
        TFT_SetPixel(x0, y0, color);
        e2 = 2 * err;
        if (e2 >= dy) { /* e_xy+e_x > 0                 */
            if (x0 == x1) break;
            err += dy;
            x0 += sx;
        }
        if (e2 <= dx) { /* e_xy+e_y < 0                 */
            if (y0 == y1) break;
            err += dx;
            y0 += sy;
        }
    }

}

//  -----------------------------------------------------------------

void TFT_DrawVerticalLine(uint16_t poX, uint16_t poY, uint16_t length, uint16_t color) {
    uint16_t i;

    TFT_SetCol(poX, poX);
    TFT_SetPage(poY, poY + length);
    TFT_SendCMD(0x2c);
    for (i = 0; i < length; i++)
        //	TFT_SendData(~color);
        TFT_SendData(color);
}

//  -----------------------------------------------------------------

void TFT_DrawRectangle(uint16_t poX, uint16_t poY, uint16_t length, uint16_t width, uint16_t color) {
    TFT_DrawHorizontalLine(poX, poY, length, color);
    TFT_DrawHorizontalLine(poX, poY + width, length, color);
    TFT_DrawVerticalLine(poX, poY, width, color);
    TFT_DrawVerticalLine(poX + length, poY, width, color);

}

//  -----------------------------------------------------------------

void TFT_DrawCircle(int poX, int poY, int r, uint16_t color) {
    int x = -r, y = 0, err = 2 - 2 * r, e2;

    do {
        TFT_SetPixel(poX - x, poY + y, color);
        TFT_SetPixel(poX + x, poY + y, color);
        TFT_SetPixel(poX + x, poY - y, color);
        TFT_SetPixel(poX - x, poY - y, color);
        e2 = err;
        if (e2 <= y) {
            err += ++y * 2 + 1;
            if (-x == y && e2 <= x) e2 = 0;
        }
        if (e2 > x) err += ++x * 2 + 1;
    } while (x <= 0);
}

//  -----------------------------------------------------------------

void TFT_FillCircle(int poX, int poY, int r, uint16_t color) {
    int x = -r, y = 0, err = 2 - 2 * r, e2;

    do {

        TFT_DrawVerticalLine(poX - x, poY - y, 2 * y, color);
        TFT_DrawVerticalLine(poX + x, poY - y, 2 * y, color);

        e2 = err;
        if (e2 <= y) {
            err += ++y * 2 + 1;
            if (-x == y && e2 <= x) e2 = 0;
        }
        if (e2 > x) err += ++x * 2 + 1;
    } while (x <= 0);

}
//      ,  
// (x, y) -      
// up_down: 1 - up, -1 - down

void TFT_SimpleTriangle(uint16_t x, uint16_t y, uint16_t height, int8_t up_down, uint16_t color) {
    uint16_t len = 1;

    if (up_down == 0) return;

    if (up_down > 0) { //  -
        while (height) {
            TFT_DrawHorizontalLine(x, y, len, color);
            x--;
            y++;
            len += 2;
            height--;
        }
    } else { //  -
        y += height;
        while (height) {
            TFT_DrawHorizontalLine(x, y, len, color);
            x--;
            y--;
            len += 2;
            height--;
        }     
    }


}

//  -----------------------------------------------------------------

void TFT_SetOrientation(uint8_t orient) {
    TFT_SendCMD(0x36);
    switch (orient) {
        case 0: TFT_WriteData(0x48);
            break;
        case 1: TFT_WriteData(0x28);
            break;
        case 2: TFT_WriteData(0x88);
            break;
        case 3: TFT_WriteData(0xE8);
            break;
    }
    if (orient == 0 || orient == 2) {
        Max_X = 239;
        Max_Y = 319;
    } else {
        Max_X = 319;
        Max_Y = 239;
    }
}

//  -----------------------------------------------------------------

void TFT_DrawChar(uint8_t ascii, uint16_t poX, uint16_t poY, uint16_t size, uint16_t fgcolor) {
    uint8_t temp = 0, k, f;
    int i;
    
    if (ascii >= 32) {
        ;
    } else {
        ascii = '?' - 32;
    }
    if (flag_bg_transparence == 0) {
        for (i = 0; i < FONT_X; i++) {
            if ((ascii >= 0x20) && (ascii <= 0x7F)) {
                temp = Font16x16[ascii - 0x20][i];
            } else if (ascii >= 0xC0) {
                temp = Font16x16[ascii - 0x65][i];
            }
            k = i / 8;
            for (f = 0; f < FONT_Y; f++) {
                if ((temp >> f)&0x01) {
                    if (size == 0)TFT_SetPixel(poX + i - (k * 8), poY + f + (k * 8), fgcolor);
                    else TFT_FillRectangle(poX + i * size - (k * 8) * size, poY + f * size + (k * 8) * size, size, size, fgcolor);
                } else {
                    if (size == 0)TFT_SetPixel(poX + i - (k * 8), poY + f + (k * 8), bg_color);
                    else TFT_FillRectangle(poX + i * size - (k * 8) * size, poY + f * size + (k * 8) * size, size, size, bg_color);
                }
            }
        }
        if (size == 0) TFT_FillRectangle(poX + FONT_Y, poY, FONT_SPACE - FONT_Y,  FONT_X, bg_color); //     
    } else {
        for (i = 0; i < FONT_X; i++) {
            if ((ascii >= 0x20) && (ascii <= 0x7F)) {
                temp = Font16x16[ascii - 0x20][i];
            } else if (ascii >= 0xC0) {
                temp = Font16x16[ascii - 0x65][i];
            }
            k = i / 8;
            for (f = 0; f < FONT_Y; f++) {
                if ((temp >> f)&0x01) {
                    if (size == 0)TFT_SetPixel(poX + i - (k * 8), poY + f + (k * 8), fgcolor);
                    else TFT_FillRectangle(poX + i * size - (k * 8) * size, poY + f * size + (k * 8) * size, size, size, fgcolor);
                }
            }
        }
    }
}


//  -----------------------------------------------------------------

void TFT_DrawString(const char *string, uint16_t poX, uint16_t poY, uint16_t size, uint16_t fgcolor) {
    while (*string) {
        if ((poX + FONT_SPACE) > Max_X) {
            poX = 1;
            poY = poY + FONT_X*size;
        }
        TFT_DrawChar(*string, poX, poY, size, fgcolor);
        if (size > 0) poX += FONT_SPACE * size;
        else poX += FONT_SPACE;
        string++;
    }
}
//     y,     
// center == 1 -   
// center == 0 -    
// pos -    
// x -    x  
// width -       
void TFT_PrintLineOnPos(unsigned int x1, unsigned char pos, const char *s, unsigned int width, unsigned short color, tAllign allign) {
    signed short x;
    unsigned short yu, yd;
    unsigned int w, i;

    x1 += DISP_X_OFFSET;
    
    yu = pos * GetFontHeight() + DISP_Y_OFFSET;
    yd = yu + GetFontHeight();
    
    w = width * GetFontWidth(); //  
    if (w > Max_X + 1) w = Max_X + 1;

    if (allign == ALLIGN_CENTER) {
        x = (w - strlen(s) * GetFontWidth()) / 2;
        x += x1; //  
        if (x < x1) x = x1; //   
    } else if (allign == ALLIGN_LEFT) {
        x = x1;
    } else { // allign == ALLIGN_RIGHT
        x = w - strlen(s) * GetFontWidth();
        x += x1; //  
    }

    TFT_FillArea(x1, x, yu, yd, bg_color); //    

    i = 0;
    while ((s[i] != 0) && (i < width) && (x < Max_X - GetFontWidth())) {
        TFT_DrawChar(s[i], x, yu, 0, color);
        x = x + GetFontWidth();
        i++;
    }
    if (x1 + w > x) {
        TFT_FillArea(x, x1 + w, yu, yd, bg_color); //    
    }
}

void TFT_DrawPic(void) //      =======================================================
{
	uint8_t Xx, Yy;

	TFT_SetCol(2,115); // x1 x2 
	TFT_SetPage(2,115); // y1 y2 
	TFT_SendCMD(0x2c); // start to write to display ram

    TFT_RSX_HI;
    TFT_CSX_LO;

	for (Xx=0; Xx<=56; Xx++) 
	{
		for (Yy=0; Yy<=56; Yy++) //  
		{
	
			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] >> 8);
			TFT_WRX_HI;

			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] & 0xFF);
			TFT_WRX_HI;

			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] >> 8);
			TFT_WRX_HI;

			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] & 0xFF);
			TFT_WRX_HI;
		}
		for (Yy=0; Yy<=56; Yy++) //  
		{
			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] >> 8);
			TFT_WRX_HI;

			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] & 0xFF);
			TFT_WRX_HI;

			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] >> 8);
			TFT_WRX_HI;

			TFT_WRX_LO;
			TFT_DATA_PORT(PixArray[Yy][Xx] & 0xFF);
			TFT_WRX_HI;
		}
	}
    TFT_CSX_HI;
}





