#ifndef __TFT_ILI9341A_H
#define __TFT_ILI9341A_H
#ifdef __cplusplus
 extern "C" {
#endif

//#include <stdint.h>
/* Created: 14.10.2013 12:48:21 Author: Ovner*/

//  ------------------------------------------------------------
#define FONT_SPACE 9
#define FONT_X 16 //    
#define FONT_Y 8 //    

#define GetFontWidth()  FONT_SPACE
#define GetFontHeight()  16

//      
#define DISP_X_OFFSET       0
#define DISP_Y_OFFSET       0
     
#define RGBConvert(red, green, blue)    (unsigned short) ((((unsigned short)(red) & 0xF8) << 8) | (((unsigned short)(green) & 0xFC) << 3) | ((unsigned short)(blue) >> 3))

#define BLACK           RGBConvert(0, 0, 0)
#define BRIGHTBLUE      RGBConvert(0, 0, 255)
#define BRIGHTGREEN     RGBConvert(0, 255, 0)
#define BRIGHTCYAN      RGBConvert(0, 255, 255)
#define BRIGHTRED       RGBConvert(255, 0, 0)
#define BRIGHTMAGENTA   RGBConvert(255, 0, 255)
#define YELLOW          RGBConvert(255, 255, 128)
#define BRIGHTYELLOW    RGBConvert(255, 255, 0)
#define LIGHTYELLOW     RGBConvert(255, 255, 150)
#define GOLD            RGBConvert(255, 215, 0)
#define BLUE            RGBConvert(0, 0, 128)
#define GREEN           RGBConvert(0, 128, 0)
#define CYAN            RGBConvert(0, 128, 128)
#define CYAN190         RGBConvert(0, 190, 180)
#define RED             RGBConvert(128, 0, 0)
#define MAGENTA         RGBConvert(128, 0, 128)
#define HIRED           RGBConvert(255, 64, 64)
#define BROWN           RGBConvert(255, 128, 0)
#define LIGHTGRAY       RGBConvert(128, 128, 128)
#define DARKGRAY        RGBConvert(64, 64, 64)
#define LIGHTBLUE       RGBConvert(128, 128, 255)
#define LIGHTGREEN      RGBConvert(128, 255, 128)
#define LIGHTCYAN       RGBConvert(128, 255, 255)
#define LIGHTRED        RGBConvert(255, 128, 128)
#define LIGHTMAGENTA    RGBConvert(255, 128, 255)
#define WHITE           RGBConvert(255, 255, 255)
#define SADDLEBROWN 	RGBConvert(139, 69, 19)
#define SIENNA      	RGBConvert(160, 82, 45)
#define PERU        	RGBConvert(205, 133, 63)
#define BURLYWOOD       RGBConvert(222, 184, 135)
#define WHEAT       	RGBConvert(245, 245, 220)
#define TAN         	RGBConvert(210, 180, 140)
#define ORANGE         	RGBConvert(255, 187, 76)
#define DARKORANGE      RGBConvert(255, 140, 0)
#define LIGHTORANGE     RGBConvert(255, 200, 0)
#define GRAY242      	RGBConvert(242, 242, 242)    
#define GRAY229      	RGBConvert(229, 229, 229)    
#define GRAY224         RGBConvert(224, 224, 224)
#define GRAY204      	RGBConvert(204, 204, 204)    
#define GRAY192         RGBConvert(192, 192, 192)
#define GRAY160         RGBConvert(160, 160, 160)
#define GRAY	        RGBConvert(128, 128, 128)
#define GRAY096         RGBConvert(96, 96, 96)
#define GRAY075         RGBConvert(75, 75, 75)
#define GRAY054         RGBConvert(54, 54, 54)
#define GRAY032         RGBConvert(32, 32, 32)
#define GRAY010         RGBConvert(10, 10, 10)

#define MIN_X	0
#define MIN_Y	0

// 
#define TFT_RDX_LO      (GPIOB->BRR = GPIO_Pin_15)
#define TFT_RDX_HI		(GPIOB->BSRR = GPIO_Pin_15)
	
#define TFT_WRX_LO      (GPIOB->BRR = GPIO_Pin_14)
#define TFT_WRX_HI		(GPIOB->BSRR = GPIO_Pin_14)
	
#define TFT_RSX_LO      (GPIOB->BRR = GPIO_Pin_13)
#define TFT_RSX_HI		(GPIOB->BSRR = GPIO_Pin_13)

#define TFT_RESX_LO     (GPIOA->BRR = GPIO_Pin_15)
#define TFT_RESX_HI		(GPIOA->BSRR = GPIO_Pin_15)

#define TFT_CSX_LO      (GPIOB->BRR = GPIO_Pin_12)
#define TFT_CSX_HI	    (GPIOB->BSRR = GPIO_Pin_12)

#define TFT_DATA_PORT_IN	(GPIOB->IDR & 0xFF)
#define TFT_DATA_PORT(x)	(GPIOB->BSRR=(x&0xFF)|(((~(uint32_t)x)<<16)&0x00FF0000))
//            - 
//#define TFT_DATA_PORT(x)	(GPIOB->ODR=GPIOB->ODR & 0xFF00 | (x & 0xFF))

#define TFT_DATA_IN()	(GPIOB->MODER &= 0xFFFF0000)
#define TFT_DATA_OUT()	(GPIOB->MODER |= 0x00005555)
     
//   --------------------------------------------------------------------
typedef enum {ALLIGN_LEFT = 0, ALLIGN_CENTER, ALLIGN_RIGHT} tAllign;

//   ------------------------------------------------------
extern uint16_t Max_X, Max_Y;
extern uint16_t bg_color;
extern uint8_t flag_bg_transparence; //   
extern uint16_t PixArray[57][57];


#define TFT_SetTextBgColor(x) bg_color = x
#define TFT_SetTextBgTransparence(x) flag_bg_transparence = x

//    ----------------------------------------
void TFT_Init(uint8_t orient);
void TFT_ClearScreen(uint16_t color);
void TFT_FillArea(uint16_t XL, uint16_t XR, uint16_t YU, uint16_t YD, uint16_t color);
void TFT_FillRectangle(uint16_t poX, uint16_t poY, uint16_t length, uint16_t width, uint16_t color);
void TFT_DrawHorizontalLine( uint16_t poX, uint16_t poY, uint16_t length,uint16_t color);
void TFT_DrawLine( uint16_t x0,uint16_t y0,uint16_t x1, uint16_t y1,uint16_t color);
void TFT_DrawVerticalLine( uint16_t poX, uint16_t poY, uint16_t length,uint16_t color);
void TFT_DrawRectangle(uint16_t poX, uint16_t poY, uint16_t length, uint16_t width,uint16_t color);
void TFT_DrawCircle(int poX, int poY, int r,uint16_t color);
void TFT_FillCircle(int poX, int poY, int r,uint16_t color);
void TFT_SimpleTriangle(uint16_t x, uint16_t y, uint16_t height, int8_t up_down, uint16_t color);
void TFT_SetOrientation(uint8_t orient);
void TFT_DrawChar( uint8_t ascii, uint16_t poX, uint16_t poY,uint16_t size, uint16_t fgcolor);
void TFT_DrawString(const char *string,uint16_t poX, uint16_t poY, uint16_t size,uint16_t fgcolor);
void TFT_SetPixelExt(uint16_t poX, uint16_t poY,uint16_t color);
void TFT_PrintLineOnPos(unsigned int x1, unsigned char y, const char *s, unsigned int width, unsigned short color, tAllign center);

void TFT_DrawPic(void);

#ifdef __cplusplus
}
#endif
#endif /* __TFT_ILI9341A_H */


